Arch MeshToShape: Difference between revisions

From FreeCAD Documentation
m (grammar and markup)
(Marked this version for translation)
(4 intermediate revisions by the same user not shown)
Line 8: Line 8:
|IconL=Arch_SplitMesh.svg
|IconL=Arch_SplitMesh.svg
|IconC=Workbench_Arch.svg
|IconC=Workbench_Arch.svg
|IconR=Arch_SelectNonSolidMeshes.png
|IconR=Arch SelectNonManifold.svg
}}
}}


Line 24: Line 24:
[[Arch_MeshToShape|Arch MeshToShape]] converts a selected [[Mesh|Mesh]] ([[Mesh_Feature|Mesh Feature]]) object into a [[Shape|Shape]] ([[Part_Feature|Part Feature]]) object.
[[Arch_MeshToShape|Arch MeshToShape]] converts a selected [[Mesh|Mesh]] ([[Mesh_Feature|Mesh Feature]]) object into a [[Shape|Shape]] ([[Part_Feature|Part Feature]]) object.


<!--T:17-->
This tool is optimized for objects with flat faces (no curves). The corresponding tool {{Button|[[File:Part_ShapeFromMesh.svg|16px]] [[Part_ShapeFromMesh|Part ShapeFromMesh]]}} from the [[Image:Workbench_Part.svg|16px]] [[Part_Module|Part Workbench]] might be more suited for objects that contain curved surfaces.
This tool is optimized for objects with flat faces (no curves). The corresponding tool {{Button|[[File:Part_ShapeFromMesh.svg|16px]] [[Part_ShapeFromMesh|Part ShapeFromMesh]]}} from the [[Image:Workbench_Part.svg|16px]] [[Part_Module|Part Workbench]] might be more suited for objects that contain curved surfaces.


Line 54: Line 55:
* If {{incode|flat}} is {{incode|True}}, it will force the wires to be perfectly planar to be sure they can be converted into faces, but this might leave gaps in the final shell.
* If {{incode|flat}} is {{incode|True}}, it will force the wires to be perfectly planar to be sure they can be converted into faces, but this might leave gaps in the final shell.
* If {{incode|cut}} is {{incode|True}}, holes in faces are made by subtraction.
* If {{incode|cut}} is {{incode|True}}, holes in faces are made by subtraction.
</translate>


<!--T:18-->
Example:
</translate>
{{Code|code=
{{Code|code=
import Arch, Mesh, BuildRegularGeoms
import Arch, Mesh, BuildRegularGeoms
Line 75: Line 78:
|[[Arch_Module|Arch]]|IconL=Arch_SplitMesh.svg
|[[Arch_Module|Arch]]|IconL=Arch_SplitMesh.svg
|IconC=Workbench_Arch.svg
|IconC=Workbench_Arch.svg
|IconR=Arch_SelectNonSolidMeshes.png
|IconR=Arch SelectNonManifold.svg
}}
}}



Revision as of 12:13, 6 March 2020

Arch MeshToShape

Menu location
Arch → Utilities → Mesh to Shape
Workbenches
Arch
Default shortcut
None
Introduced in version
-
See also
Arch SplitMesh, Arch RemoveShape

Description

Arch MeshToShape converts a selected Mesh (Mesh Feature) object into a Shape (Part Feature) object.

This tool is optimized for objects with flat faces (no curves). The corresponding tool Part ShapeFromMesh from the Part Workbench might be more suited for objects that contain curved surfaces.

Usage

  1. Select a mesh object.
  2. Press the Mesh to Shape entry in Arch → Utilities → Mesh to Shape.

Properties

Limitations

Scripting

See also: Arch API and FreeCAD Scripting Basics.

This tool can be used in macros and from the Python console by using the following function:

new_obj = meshToShape(obj, mark=True, fast=True, tol=0.001, flat=False, cut=True)

The above code snippet converts the given obj (a mesh), into a shape, joining coplanar facets.

  • If mark is True, non-solid objects will be marked in red.
  • If fast is True, it uses a faster algorithm by building a shell from the facets then removing splitter.
  • tol is the tolerance used when converting mesh segments to wires.
  • If flat is True, it will force the wires to be perfectly planar to be sure they can be converted into faces, but this might leave gaps in the final shell.
  • If cut is True, holes in faces are made by subtraction.

Example:

import Arch, Mesh, BuildRegularGeoms

Box = FreeCAD.ActiveDocument.addObject("Mesh::Cube", "Cube")
Box.Length = 1000
Box.Width = 2000
Box.Height = 1000
FreeCAD.ActiveDocument.recompute()

new_obj = Arch.meshToShape(Box)